
import inspect as _inspect
import functools as _functools
import types as _types

import brickv.PyQt5Wrapper.QtWrapper as Qt
import brickv.PyQt5Wrapper.QtCoreWrapper as QtCore
import brickv.PyQt5Wrapper.QtGuiWrapper as QtGui
import brickv.PyQt5Wrapper.QtWidgetsWrapper as QtWidgets

def _create_wrapper(cls):
    #print('_create_wrapper_class', cls)
    """class Wrapper(cls):
        _wrapper_methods = {}

        def __getattribute__(self, name):
            print('__getattribute__', name)
            attr = super().__getattribute__(name)
            print('__getattribute__', name, attr)

            if _inspect.isbuiltin(attr):
                if name not in self._wrapper_methods:
                    self._wrapper_methods[name] = _functools.partial(self._wrapper, attr)

                return self._wrapper_methods[name]

            return attr

        def _wrapper(self, func, *args, **kwargs):
            print(func)
            return func(*args, **kwargs)

    return Wrapper"""

    def create_wrapper(func):
        def wrapper(*args, **kwargs):
            #print(func, *args, **kwargs)
            try:
                return func(*args, **kwargs)
            except TypeError:
                # float vs int?
                new_args = list(args)
                float_found = False

                for i, arg in enumerate(args):
                    if isinstance(arg, float):
                        new_args[i] = int(arg)
                        float_found = True

                try:
                    print('args', args, 'new_args', new_args)
                    if float_found:
                        return func(*tuple(new_args), **kwargs)
                    else:
                        # static function called as object function? drop self and try again
                        return func(*args[1:], **kwargs)
                except TypeError:
                    try:
                        # static function called as object function? drop self and try again
                        return func(*args[1:], **kwargs)
                    except:
                        import traceback
                        traceback.print_exc()
                        raise
                except:
                    import traceback
                    traceback.print_exc()
                    raise
            except:
                import traceback
                traceback.print_exc()
                raise

        return wrapper

    for key, value in list(_inspect.getmembers(cls, lambda value: _inspect.isbuiltin(value))):
        if key.startswith('__'):
            continue

        setattr(cls, key, create_wrapper(value))

    """__new_foobar__ = cls.__new__

    def __new__(cls_, *args, **kwargs):
        try:
            self = __new_foobar__(cls_, *args, **kwargs)
        except TypeError:
            self = object.__new__(cls_)

        for key, value in list(_inspect.getmembers(self, lambda value: _inspect.isbuiltin(value))):
            if key.startswith('__'):
                continue

            def wrapper(*args, **kwargs):
                print(value, *args, **kwargs)
                return value(*args, **kwargs)

            setattr(self, key, wrapper)

        return self

    cls.__new__ = __new__"""

    return cls

for mod in [Qt, QtCore, QtGui, QtWidgets]:
    for _key, _value in list(mod.__dict__.items()):
        if _inspect.isclass(_value):
            _value = _create_wrapper(_value)

        mod.__dict__[_key] = _value
